using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Runtime.InteropServices; //requirement class

namespace CShare.NET2005
{
    public partial class MainForm : Form
    {
        //Interface definitions.
        //==============================================================================================================
        [DllImport("pcltotiff", CallingConvention = CallingConvention.StdCall)]
        public static extern int oakBegin();

        [DllImport("pcltotiff", CallingConvention = CallingConvention.StdCall)]
        public static extern int oakEnd(int nHandle);

        [DllImport("pcltotiff", CallingConvention = CallingConvention.StdCall)]
        public static extern int oakExport(int nHandle);

        [DllImport("pcltotiff", CallingConvention = CallingConvention.StdCall)]
        public static extern int oakSetOption(int nHandle,  //Conversion object's handle.
                                                int nIndex,   //Property tag,refer to the following property definitions.
                                                int nValue1,  
                                                int nValue2,   
                                                string lpValue1,  
                                                string lpValue2);

        [DllImport("pcltotiff", CallingConvention = CallingConvention.StdCall)]
        public static extern int oakGetOption(int nHandle,  //Conversion object's handle.
                                                int nIndex,   //Property tag,refer to the following property definitions.
                                                int nValue1,
                                                int nValue2,
                                                string lpValue1,
                                                string lpValue2);

        //Definitions of oakSetOption's nIndex properties 
        //==============================================================================================================
        const int OAK_Set_Output       =  2101;
        const int OAK_Set_Input        =  2102;
        const int OAK_Set_DPI          =  2103;
        const int OAK_Set_ColorDepth = 2104;
        const int OAK_Set_Compression = 2108;
        const int OAK_Set_Quality      =  2109;


        //TIFF tag's definitions.
        //==============================================================================================================
        const int OAK_COMPRESSION_NONE        =  1;
        const int OAK_COMPRESSION_RLE         =  2;
        const int OAK_COMPRESSION_G3          =  3;
        const int OAK_COMPRESSION_G4          =  4;
        const int OAK_COMPRESSION_LZW         =  5;
        const int OAK_COMPRESSION_JPEG        =  6;
        const int OAK_COMPRESSION_PACKBITS    =  7;
               
        //Color Depth
        //==============================================================================================================
        const int oak_color_1 = 1;    //2 colors
        const int oak_color_4 = 4;    //16 colors
        const int oak_color_8_g = 7;  //256 grayscale colors
        const int oak_color_8 = 8;    //256 colors
        const int oak_color_24 = 24;  //true colors

        //==============================================================================================================


        const int TRUE = 1;
        const int FALSE = 0;
        //==============================================================================================================

        public MainForm()
        {
            InitializeComponent();
        }

        //==============================================================================================================
        private void btnDemo1_Click(object sender, EventArgs e)
        {
            int id;
            int isMultiPage; 
            int xdpi, ydpi;
            int iCompression;
            string sOutTifFname;


                //================================================================
            id = oakBegin();
            if (id > 0)
            {
	            //set output file
	            isMultiPage = FALSE;
	            sOutTifFname = "lzw.tif";
	            oakSetOption(id, OAK_Set_Output, 0, isMultiPage, sOutTifFname, "");
    			
	            //set dpi
                xdpi = 150; 
                ydpi = 150;
	            oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, "", "");
    			
	            //set compress
	            iCompression = OAK_COMPRESSION_LZW;
                oakSetOption(id, OAK_Set_Compression, iCompression, 0, "", "");
    			
	            //set input file
	            oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test1.pcl", "");
	            oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test2.pcl", "");
	            oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test3.pcl", "");
    			
	            //strat convert
	            oakExport(id);

	            oakEnd(id);
            }

            //================================================================
            id = oakBegin();
            if (id > 0)
            {
                //set output file
                isMultiPage = TRUE;
                sOutTifFname = "MultiPage_g4.tif";
                oakSetOption(id, OAK_Set_Output, 0, isMultiPage, sOutTifFname, "");

                //set dpi
                xdpi = 150;
                ydpi = 150;
                oakSetOption(id, OAK_Set_DPI, xdpi, ydpi, "", "");

                //Color Depth
                oakSetOption(id, OAK_Set_ColorDepth, oak_color_1, 0, "", "");

                //set compress
                iCompression = OAK_COMPRESSION_G4;
                oakSetOption(id, OAK_Set_Compression, iCompression, 0, "", "");

                //set input file
                oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test1.pcl", "");
                oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test2.pcl", "");
                oakSetOption(id, OAK_Set_Input, 0, 0, ".\\pcl_files\\test3.pcl", "");

                //strat convert
                oakExport(id);
     			
	            oakEnd(id);
                MessageBox.Show("Conversion successful");
           }

        }


        private void MainForm_Load(object sender, EventArgs e)
        {

        }


    }
}